package com.glxp.udidl.admin.service.DataSync;

import com.glxp.udidl.admin.util.Md5Utils;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

@Service
public class UdplatDownloadService {
    private String host="http://pre-mcs.udplat.org";//"http://120.32.125.20";//"http://pre.udplat.org/deal";"http://pre.udplat.org";//
    private String appId="20004072";
    private String secretKey="hoGxLSEsSyysnS9";
    private String userName="漳州片仔癀诊断";
    private long getTime(){
       return System.currentTimeMillis();
    }
    private  String getSign(String time){
        TreeMap<String,String> map= new TreeMap<>();
        map.put("appId",appId);
        map.put("userName", URLEncoder.encode(userName));
        map.put("time",time);
        map.put("secretKey",secretKey);
        StringBuffer sb = new StringBuffer();
        for(Map.Entry<String,String> entry:map.entrySet()){
            sb.append(entry.getKey()+"="+entry.getValue());
            sb.append("&");
        }
        String str = sb.toString();
        String str0 = str.substring(0,str.length()-1);
        System.out.println("签名前："+str0);
        String result = Md5Utils.stringToMD5(str0);
        System.out.println("签名："+result);
        return result;
    }
    private Map<String, String> getHeader(){
        Map<String, String> map = new HashMap<>();
        String time = getTime()+"";
        time = time.substring(0,time.length()-3);
        map.put("appId",appId);
        map.put("userName", userName);
        map.put("time",time);
        map.put("secretKey",secretKey);
        map.put("sign",getSign(time));
        return map;
    }
    public String getDistributor(){
        String url="/hsapi/purchase/distributors";
        String result = post(url,getHeader(),null);
        return result;
    }
    private String post(String url, Map<String, String> headerMap, Object jsonObject) {
        HttpHeaders httpHeaders = new HttpHeaders();
        for (Map.Entry<String, String> stringStringEntry : headerMap.entrySet()) {
            httpHeaders.add(stringStringEntry.getKey(), stringStringEntry.getValue());
        }
        httpHeaders.add("Content-Type", "application/json");
        HttpEntity httpEntity = new HttpEntity(jsonObject, httpHeaders);
        RestTemplate restTemplate = new RestTemplate();
        String result = restTemplate.postForObject(host+url, httpEntity, String.class);
        return result;
    }
}
